=== debian/changelog ===
yosys (0.5.0-1) unstable; urgency=low

  * New upstream release
  * Added d/watch
  * Updated copyright years in d/copyright
  * Changed dependency from tcl8.5-dev to tcl-dev
  * Added d/gbp.conf
  * Added link from /usr/bin/yosys-abc to /usr/bin/berkeley-abc
    - Also added man page for yosys-abc
  * Fixed paths returned by yosys-config
    - fix included in 04_installpath.patch

 -- Ruben Undheim <ruben.undheim@gmail.com>  Mon, 09 Feb 2015 20:37:38 +0100

yosys (0.4.0-1) unstable; urgency=medium

  * New upstream release
  * Few fixes in d/copyright
  * Removed some strictly not needed dependencies

 -- Ruben Undheim <ruben.undheim@gmail.com>  Wed, 12 Nov 2014 18:35:59 +0100

yosys (0.3.0+20140906git652345c-1) unstable; urgency=low

  * Initial release (Closes: #761365)

 -- Ruben Undheim <ruben.undheim@gmail.com>  Thu, 16 Oct 2014 22:02:03 +0200
