## yosys 0.5.0%2B20151013gitf13e387

=== debian/rules ===
--- 
+++ 
@@ -6,7 +6,7 @@
 export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
 
 %:
-	dh $@ 
+	PREFIX=/usr dh $@
 
 
 override_dh_auto_configure:
