=== debian/control ===
--- 
+++ 
@@ -10,10 +10,11 @@
                flex,
                gawk,
                libffi-dev,
-               pkg-config
+               pkg-config,
+               python3
 Standards-Version: 3.9.6
 Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/yosys.git
-Vcs-Git: git://anonscm.debian.org/debian-science/packages/yosys.git
+Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/yosys.git
 Homepage: http://www.clifford.at/yosys
 
 Package: yosys
