=== debian/changelog ===
yosys (0.6-7) unstable; urgency=medium

  [ Ruben Undheim ]
  * Use gbp-pq for patches.
  * debian/control:
    - Removed dependency on GCC 5 which was added in 0.6-6. (Closes: #835953)
      It causes problems now since GCC 6 is default.

  [Sebastian Kuzminsky]
  * debian/patches/switch-to-free-font.patch: Switch manual tt font
    from libertine to inconsolata.  The yosys manual doesn't render with
    libertine on sid, but it renders nicely with inconsolata. (Closes: #835678)

 -- Ruben Undheim <ruben.undheim@gmail.com>  Thu, 22 Sep 2016 19:30:37 +0200

yosys (0.6-6) unstable; urgency=medium

  * Added versioned build-dependency on gcc-5 (>= 5.3.1-15) since it
    now fails to build with older versions due to the fix for #822408.
    (Closes: #823809)
  * Updated Standards to 3.9.8 - no changes

 -- Ruben Undheim <ruben.undheim@gmail.com>  Wed, 11 May 2016 22:20:00 +0200

yosys (0.6-5) unstable; urgency=medium

  [ Sebastian Kuzminsky ]
  * debian/patches/fixup-initalization.patch:
    - Add a bugfix patch from upstream's development branch.

  [ Ruben Undheim ]
  * debian/patches/fix_ftbfs_cannot_find_infinite.patch:
    - Fixes FTBFS due to std::isfinite not found. (Closes: #822408)
  * Move PDFs in yosys-doc to /usr/share/doc/yosys in order to adhere to
    Debian Policy 12.3.
  * Refreshed patches

 -- Ruben Undheim <ruben.undheim@gmail.com>  Tue, 03 May 2016 21:56:53 +0200

yosys (0.6-4) unstable; urgency=medium

  * debian/rules:
    - Override dh_auto_build-arch instead of dh_auto_build to resolve
      build issue for "all" package.

 -- Ruben Undheim <ruben.undheim@gmail.com>  Sat, 09 Apr 2016 16:38:20 +0200

yosys (0.6-3) unstable; urgency=medium

  [ Sebastian Kuzminsky ]
  * debian/patches/kfreebsd-support.patch:
    - Fix a build problem on kFreeBSD. Use __unix__ instead of __linux__

  [ Ruben Undheim ]
  * debian/control:
    - Define Build-Depends-Indep dependencies
  * debian/rules:
    - Override dh_auto_build-indep instead for building documentation.

 -- Ruben Undheim <ruben.undheim@gmail.com>  Sat, 09 Apr 2016 14:29:32 +0200

yosys (0.6-2) unstable; urgency=medium

  * split the package into yosys, yosys-dev, and yosys-doc
    - yosys is the tool itself
    - yosys-dev is development files for building plugins
    - yosys-doc is the manual (in pdf format)
  * debian/rules:
    - fail the build if upstream installs files that aren't picked up
      by any of the debs

 -- Sebastian Kuzminsky <seb@highlab.com>  Wed, 23 Mar 2016 18:46:51 -0600

yosys (0.6-1) unstable; urgency=medium

  * Uploaded to unstable.
  * New upstream release: 0.6 (5869d26)
    - 01_gitrevision.patch: refresh
    - spelling-fixes.patch: fix upstream spelling mistakes
  * debian/rules:
    - don't run make as part of dh_auto_configure, it'll get run by
        dh_auto_build later
    - enable parallel build
    - handle the new python dependencies of yosys-smtbmc
  * debian/control:
    - add Sebastian Kuzminsky to Uploaders
  * add a manpage for the new yosys-smtbmc executable

 -- Sebastian Kuzminsky <seb@highlab.com>  Sun, 28 Feb 2016 10:48:44 -0700

yosys (0.5.0+20151013gitf13e387-2~exp1) experimental; urgency=low

  * Added autopkg test for synthesis for iCE FPGA.
  * Updated standards to 3.9.7 - no needed changes

 -- Ruben Undheim <ruben.undheim@gmail.com>  Sun, 21 Feb 2016 12:21:37 +0100
