=== debian/control ===
--- 
+++ 
@@ -1,8 +1,10 @@
 Source: yosys
 Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
-Uploaders: Ruben Undheim <ruben.undheim@gmail.com>
+Uploaders: Ruben Undheim <ruben.undheim@gmail.com>,
+           Sebastian Kuzminsky <seb@highlab.com>
 Section: electronics
 Priority: optional
+Testsuite: autopkgtest
 Build-Depends: debhelper (>= 9),
                tcl-dev,
                libreadline-dev,
@@ -11,8 +13,23 @@
                gawk,
                libffi-dev,
                pkg-config,
+               txt2man,
                python3
-Standards-Version: 3.9.6
+Build-Depends-Indep:
+               texlive-base,
+               texlive-generic-recommended,
+               texlive-fonts-recommended,
+               texlive-fonts-extra,
+               texlive-latex-base,
+               texlive-latex-extra,
+               texlive-font-utils,
+               texlive-science,
+               texlive-publishers,
+               texlive-bibtex-extra,
+               lmodern,
+               graphviz,
+               berkeley-abc (>= 1.01)
+Standards-Version: 3.9.8
 Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/yosys.git
 Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/yosys.git
 Homepage: http://www.clifford.at/yosys
@@ -20,6 +37,7 @@
 Package: yosys
 Architecture: any
 Depends: ${shlibs:Depends},
+         ${python3:Depends},
          ${misc:Depends},
          berkeley-abc (>= 1.01),
          xdot
@@ -31,3 +49,35 @@
  Yosys can be adapted to perform any synthesis job by combining the existing
  passes (algorithms) using synthesis scripts and adding additional passes as
  needed by extending the yosys C++ code base.
+
+Package: yosys-dev
+Architecture: any
+Depends: ${shlibs:Depends},
+         ${python3:Depends},
+         ${misc:Depends}
+Description: Framework for Verilog RTL synthesis (development files)
+ Yosys is a framework for Verilog RTL synthesis. It currently has extensive
+ Verilog-2005 support and provides a basic set of synthesis algorithms for
+ various application domains.
+ .
+ Yosys can be adapted to perform any synthesis job by combining the existing
+ passes (algorithms) using synthesis scripts and adding additional passes as
+ needed by extending the yosys C++ code base.
+ .
+ This package contains the headers and programs needed to build yosys plugins.
+
+Package: yosys-doc
+Section: doc
+Architecture: all
+Depends: ${misc:Depends}
+Suggests: yosys
+Description: Documentation for Yosys
+ Yosys is a framework for Verilog RTL synthesis. It currently has extensive
+ Verilog-2005 support and provides a basic set of synthesis algorithms for
+ various application domains.
+ .
+ Yosys can be adapted to perform any synthesis job by combining the existing
+ passes (algorithms) using synthesis scripts and adding additional passes as
+ needed by extending the yosys C++ code base.
+ .
+ This package contains the manual.
